/* Copyright IBM Corp. 2010 All Rights Reserved. */
(function() {
    if (typeof com == "undefined" || !com) {
        com = {};
    }
    if (typeof com.ibm == "undefined" || !com.ibm) {
        com.ibm = {};
    }
    if (typeof com.ibm.ajaxproxy == "undefined" || !com.ibm.ajaxproxy) {
        com.ibm.ajaxproxy = {};
    }

    if (typeof com.ibm.ajaxproxy.base64 == "undefined"
            || !com.ibm.ajaxproxy.base64) {
        com.ibm.ajaxproxy.base64 = {};
    }

    if (typeof com.ibm.ajaxproxy.cookie != "undefined"
            && com.ibm.ajaxproxy.cookie) {
        return;
    }

    var p = "!";
    var tab = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_-";
    var ap = com.ibm.ajaxproxy;

    ap.base64.decode = function(/* string */str) {
        // summary
        // Convert a base64-encoded string to an array of bytes
        var s = str.split(""), out = [];
        var l = s.length;
        while (s[--l] == p) {
        } // strip off trailing padding
        for ( var i = 0; i < l;) {
            var t = tab.indexOf(s[i++]) << 18;
            if (i <= l) {
                t |= tab.indexOf(s[i++]) << 12
            }
            ;
            if (i <= l) {
                t |= tab.indexOf(s[i++]) << 6
            }
            ;
            if (i <= l) {
                t |= tab.indexOf(s[i++])
            }
            ;
            out.push((t >>> 16) & 0xff);
            out.push((t >>> 8) & 0xff);
            out.push(t & 0xff);
        }
        // strip off any null bytes
        while (out[out.length - 1] == 0) {
            out.pop();
        }
        return out; // byte[]
    };

    ap.base64.atos = function(ba) {
        var rStr = "";
        for ( var i = 0; i < ba.length; i++) {
            rStr += String.fromCharCode(ba[i]);
        }
        return rStr;
    };

    ap.base64.stoa = function(str) {
        var ba = [];
        for ( var i = 0; i < str.length; i++) {
            ba[i] = str.charCodeAt(i);
        }

        return ba;
    };

    ap.trim = function(str) {
        return str.replace(/(^\s+)|(\s+$)/g, "");
    }

    /**
     * Retrieves the value of the cookie identified by <tt>name</tt>.
     * 
     * @param {String} name
     *            the Name of the cookie to retrieve
     * @param {String} domain
     *            the domain of the cookie to retrieve
     * @return {String} the value of the cookie specified with <tt>name</tt>
     */
    ap.cookie = function(name, domain) {
        if (arguments.length == 0) {
            return null;
        }

        var retVal;

        if (arguments.length <= 2) {
            // read case
            var cookies = document.cookie.split(";");

            for ( var i in cookies) {
                if (Object.prototype.hasOwnProperty.call(cookies, i)) {
                    var cookie = ap.trim(cookies[i]);

                    // if we have a plain text cookie, return it directly
                    if (cookie.indexOf(name + "=") == 0) {
                        return cookie.substr(cookie.lastIndexOf("="));
                    }

                    // see if the cookie matches a proxified cookie
                    if (cookie.indexOf("prx_") != 0
                            || cookie.indexOf("." + name) == -1) {
                        continue;
                    }

                    // we found the cookie so let's split it up
                    var b64Str = cookie.substring(4, cookie.indexOf("."));

                    // get the bytes
                    var ba = com.ibm.ajaxproxy.base64.decode(b64Str);

                    // get the string from the bytes
                    var plainCookie = com.ibm.ajaxproxy.base64.atos(ba);

                    // now split plainCookie
                    var cookieParts = plainCookie.split(";");

                    // get the domain
                    var cDomain = "";
                    for ( var p in cookieParts) {
                        if (Object.prototype.hasOwnProperty
                                .call(cookieParts, p)) {
                            var part = cookieParts[p];

                            if (part.indexOf("d=") == 0) {
                                cDomain = part.substr(2);
                                break;
                            }
                        }
                    }

                    // match the requested domain against the current domain or
                    // if
                    // no domain was specified accept any
                    if (!domain || domain === cDomain) {
                        retVal = cookie.substr(cookie.lastIndexOf("=") + 1);
                        break;
                    }
                }
            }

            return retVal;
        }
    }
})();